package com.bs.framework.web.service;

import cn.hutool.core.lang.Validator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.bs.common.constant.CacheConstants;
import com.bs.common.constant.Constants;
import com.bs.common.constant.UserConstants;
import com.bs.common.core.domain.entity.SysUser;
import com.bs.common.core.domain.model.RegisterBody;
import com.bs.common.core.redis.RedisCache;
import com.bs.common.exception.user.CaptchaException;
import com.bs.common.exception.user.CaptchaExpireException;
import com.bs.common.utils.MessageUtils;
import com.bs.common.utils.SecurityUtils;
import com.bs.common.utils.StringUtils;
import com.bs.framework.manager.AsyncManager;
import com.bs.framework.manager.factory.AsyncFactory;
import com.bs.system.service.ISysConfigService;
import com.bs.system.service.ISysUserService;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.Date;
import java.util.Random;

/**
 * 注册校验方法
 *
 * @author bs
 */
@Component
public class SysRegisterService
{
    @Autowired
    private ISysUserService userService;

    @Autowired
    private ISysConfigService configService;

    @Autowired
    private RedisCache redisCache;

    /**
     * 注册
     */
    public String register(RegisterBody registerBody)
    {
        String msg = "", username = registerBody.getUsername(), password = registerBody.getPassword();
        SysUser sysUser = new SysUser();
        sysUser.setUserName(username);
        sysUser.setReviewStatus("1");
        sysUser.setPhonenumber(registerBody.getPhonenumber());
        // 验证码开关
//        boolean captchaEnabled = configService.selectCaptchaEnabled();
//        if (captchaEnabled)
//        {
//            validateCaptcha(username, registerBody.getCode(), registerBody.getUuid());
//        }
        if (StringUtils.isEmpty(username))
        {
            msg = "用户名不能为空";
        }
        else if (StringUtils.isEmpty(password))
        {
            msg = "用户密码不能为空";
        }
        else if (username.length() < UserConstants.USERNAME_MIN_LENGTH
                || username.length() > UserConstants.USERNAME_MAX_LENGTH)
        {
            msg = "账户长度必须在2到20个字符之间";
        }
        else if (password.length() < UserConstants.PASSWORD_MIN_LENGTH
                || password.length() > UserConstants.PASSWORD_MAX_LENGTH)
        {
            msg = "密码长度必须在5到20个字符之间";
        }
        else if (!userService.checkUserNameUnique(sysUser))
        {
            msg = "保存用户'" + username + "'失败，注册账号已存在";
        }
        else if (Validator.isNotEmpty(sysUser.getPhonenumber()) && !userService.checkPhoneUnique(sysUser)) {
            msg = "新增用户'" + sysUser.getUserName() + "'失败，手机号码已存在";
        }
        else
        {
            if (!StringUtils.isEmpty(registerBody.getShareUser())) {
                SysUser sysUserShare = userService.selectUserById(Long.valueOf(registerBody.getShareUser()));
                Long deptId = sysUserShare.getDeptId();
                sysUser.setDeptId(deptId);
                if (-1 == deptId) {
                    sysUser.setDeptId(0L);
                }
            } else {
                sysUser.setDeptId(0L);
            }
            sysUser.setPhonenumber(registerBody.getPhonenumber());
            sysUser.setUserType("jj");
            sysUser.setTenantId(0L);
            sysUser.setNickName(username);
            sysUser.setPassword(SecurityUtils.encryptPassword(password));
            Date date = new Date();
            LocalDateTime localDateTime = date.toInstant()
                    .atZone(ZoneId.systemDefault())
                    .toLocalDateTime();
            sysUser.setCreateTime(localDateTime);
            sysUser.setBrokerId(registerBody.getShareUser());
            Long newId = System.currentTimeMillis() + new Random().nextInt(1000);
            sysUser.setUserId(newId);
            boolean regFlag = userService.registerUser(sysUser);
            userService.registerUserByBroker(sysUser);
            if (!regFlag)
            {
                msg = "注册失败,请联系系统管理人员";
            }
            else
            {
                AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.REGISTER, MessageUtils.message("user.register.success")));
            }
        }
        return msg;
    }

    /**
     * 校验验证码
     *
     * @param username 用户名
     * @param code 验证码
     * @param uuid 唯一标识
     * @return 结果
     */
    public void validateCaptcha(String username, String code, String uuid)
    {
        String verifyKey = CacheConstants.CAPTCHA_CODE_KEY + StringUtils.nvl(uuid, "");
        String captcha = redisCache.getCacheObject(verifyKey);
        redisCache.deleteObject(verifyKey);
        if (captcha == null)
        {
            throw new CaptchaExpireException();
        }
        if (!code.equalsIgnoreCase(captcha))
        {
            throw new CaptchaException();
        }
    }
}
